<!-- part of the HEAD section -->

<!-- part of the BODY section -->
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-
//1307, USA.


// CONSTANTS
// The default length of an edit field
var DEFAULT_EDIT_FIELD_LENGTH = 10;
// The servlet that handles the return values
var RETURN_SERVLET = "/servlet/OpenPortal";

// METHODS
// A property has been clicked on by the mouse; take appropriate action.
// In this case it means replacing the clicked on property with an 
// edit field.
function propertySelected(e) {
	// Keep looping until we get to a tag that is of the 
	// WebletProperty class.
	// This is needed because if a user clicks on an area
	// within a large weblet property, such as an articles text,
	// the inital e.srcElement that is returned will be the
	// HTML element within the WebletProperty class, such as a
	// <P> tag, and not the <SPAN> for the weblet property
	// itself; we need to loop through the e.srcElement's
	// parents until we hit a tag that is of the WebletProperty
	// class (i.e. it has the tag attribute CLASS="WebletProperty")
	var propertyClass = e.srcElement.className;
	var correctObj = e.srcElement;
	while (propertyClass != "WebletProperty") {
		correctObj = e.srcElement.parentElement;
		propertyClass = correctObj.className;
	}
	// replace the entire span element with a form tag
	// see if the weblet property has its own replaceWithForm method defined
	if ((typeof correctObj.replaceWithForm) == "undefined")
	   replaceWithForm(correctObj);   // use default method
	else
	   correctObj.replaceWithForm(correctObj);
}
// Replaces a property element with an edit field 
function replaceWithForm(somePropertyElem) {
    // get the current inner html value & id
	var currentInnerHTML = somePropertyElem.innerHTML;
	var currentID = somePropertyElem.id;
	// find out how long to make the edit field
	var fieldLen = DEFAULT_EDIT_FIELD_LENGTH;
	if (currentInnerHTML.length > fieldLen)
	   // just use the number of characters already in the property
	   fieldLen = currentInnerHTML.length;
	// the SUBMIT button needs to somehow encode the name of the ID for
	// the property, so that we can get it out of the document when the button
	// is pressed; we do this by giving the SUBMIT button it's own ID equal
	// to the name of the properties ID plus the string '_Submit'
	var submitID = currentID+"_Submit";
	// convert all breaks into newlines
	//currentInnerHTML = currentInnerHTML.replace(/<BR>/g, "\n");
	// replace with a form tag
	somePropertyElem.outerHTML = 
			"<input type=text id='"+currentID+"' value='"+currentInnerHTML+"' size="+fieldLen+">"+
			"<input type=submit id='"+submitID+"' value='Save' onclick='saveProperty(event)'>";
	// move any methods that have been overridden to the new INPUT tag,
	// such as a custom replaceWithForm() method or saveProperty()
	moveMethods(somePropertyElem, document.all[currentID]);
}
// Copies over special overridden methods like replaceWithForm()
// and saveProperty() when a SPAN tag is changed into an INPUT
// tag, or vice versa
function moveMethods(from, to) {
    // make sure 'from' has replaceWithForm method
	if (from.replaceWithForm != void 0)
       to.replaceWithForm = from.replaceWithForm;
	// make sure 'from' has saveProperty method
	if (from.saveProperty != void 0)
	   to.saveProperty = to.saveProperty;
}
// This method is called when the SAVE button for a property we are
// currently inline editing is pushed, or when the ENTER key is pressed
function saveProperty(e) {
    // get the submit button
	var submitButton = e.srcElement;
	// use the ID of the submit button to extract the name of the weblet
	// property
	var correctName = submitButton.id.split(/_Submit/);
	// delete the submit button
	submitButton.outerHTML = "";
    // get the INPUT field that contains the new stuff we want
    var newInput = document.all[correctName];
	// see if the INPUT tag, which was previously a SPAN tag, 
	// has its own special over-ridden version of saveProperty
	if (newInput.saveProperty != void 0)
	   newInput.saveProperty(theForm);
	else {
	   // the new stuff that was entered
	   var newValue = newInput.value;
	   // the id that will be used to reconstruct the SPAN for the
	   // weblet property
	   var newID = newInput.id;
	   // convert all newlines into breaks <BR>s
	   newValue = newValue.replace(/\n/g, "<BR>")
	   // reconstruct the SPAN tag with the new value
	   newInput.outerHTML = "<span id='"+newID+"' class=WebletProperty onclick='propertySelected(event)'>"+newValue+"</span>";
	   // now swap out the saved methods that were saved in the INPUT tag into the
	   // new SPAN tag (i.e. overridden methods like replaceWithForm() and saveProperty()
	   moveMethods(newInput, document.all[newID]);
	   // now save the new value back to the server
	   newInput.value = newValue;
	   saveNewValueToServer(newInput);
	}
} 
// Saves the value of the newly edited field back to the server using a POST request
function saveNewValueToServer(newInput) {
    var newForm = "<form method=POST action='http://"+RETURN_SERVLET+"'>"+
	    "<input type=hidden name='action' value='save'>"+
		"<input type=hidden name='action_type' value='single_field'>"+
		"<input type=hidden name='weblet_name' value='"+newInput.id+"'>"+
		"<input type=hidden name='"+newInput.id+"' value='"+newInput.value+"'>"+
		"</form>";
}
// Changes the text inside a property to say 'Click here to edit' whenever the weblet
// property gains the focus.
// NOT CURRENTLY USED
function showEditMessage(e) {
    document.all["console"].innerHTML = "inside show";
    // get the tag that got the focus
    var currentTag = e.srcElement;
    // save the old value of the innerHTML
    currentTag.old_innerHTML = currentTag.innerHTML;
    // add our new message
    currentTag.innerHTML = "Click here to edit";
}
// Hides the 'Click here to edit' message and restores a weblet property's old value
// when it loses the focus.
// NOT CURRENTLY USED
function hideEditMessage(e) {
    var currentTag = e.srcElement;
    // restore the old value of the inner HTML
    currentTag.innerHTML = currentTag.old_innerHTML;
} 
